#pragma once
#ifndef __Canvas_H__
#define __Canvas_H__

class Canvas : public Widget
{
public:
	Canvas(Vector2n Position, bool Centered, bool HasBackground);
	~Canvas();

	void Render();

	void AddWidget(Widget * Widget);

	bool HitTest(Vector2n Position, std::list<Widget *> * Hits) const;

	void ProcessButton(Pointer * Pointer, Input::InputId ButtonId, bool Pressed);
	void ProcessSlider(Pointer * Pointer, Input::InputId SliderId, double MovedAmount);
	
	void MoveView(uint8 Degree, double MoveAmount, double A[2] = 0);
	void RenderBackground();
	void SetupTransform();
	void EndTransform();
	const bool GlobalIsInsideCanvas(const Vector2n Position) const;
	const Vector2d GlobalToCanvas(const Vector2n Position) const;
	void SetDimensions(Vector2n Dimensions);

private:
	Canvas(const Canvas &);
	Canvas & operator =(const Canvas &);

	Vector2d Camera;
	double CameraZ;

	bool		m_Centered;
	bool		m_HasBackground;

	std::vector<std::unique_ptr<Widget>>		m_Widgets;
};

#endif // __Canvas_H__
