#include "../../Main.h"

MousePointer::MousePointer()
	: Pointer(),
	  m_ButtonsPressed(1, false)
{
}

MousePointer::~MousePointer()
{
}

void MousePointer::ProcessButton(Input::InputId ButtonId, bool Pressed)
{
	// If no buttons were pressed thus far, then the pointer is getting activated
	if (Pressed && !AnyButtonsPressed())
	{
		Pointer::ProcessActivation();
	}

	// Expand the buttons array to fit this button, if neccessary
	while (m_ButtonsPressed.size() <= ButtonId)
		m_ButtonsPressed.push_back(false);

	m_ButtonsPressed[ButtonId] = Pressed;

	Pointer::ProcessButton(ButtonId, Pressed);

	// If no buttons are pressed anymore, then the pointer is getting deactivated
	if (!Pressed && !AnyButtonsPressed())
	{
		Pointer::ProcessDeactivation();
	}
}

void MousePointer::ProcessPosition(Vector2n Position)
{
}

// Returns true if any of the buttons are pressed, otherwise false
bool MousePointer::AnyButtonsPressed() const
{
	for (const auto & ButtonPressed : m_ButtonsPressed)
	{
		if (ButtonPressed)
			return true;
	}

	return false;
}
