#include "../../Main.h"

Pointer::Pointer()
	: m_WidgetMapping(),
	  m_IsActive(false)
{
	m_WidgetMapping.ProcessPointerCreation(this);
}

Pointer::~Pointer()
{
	m_WidgetMapping.ProcessPointerDeletion(this);
}

void Pointer::ProcessActivation()
{
	m_IsActive = true;
	m_WidgetMapping.ProcessPointerActivation(this);
}

void Pointer::ProcessDeactivation()
{
	m_IsActive = false;
	m_WidgetMapping.ProcessPointerDeactivation(this);
}

bool Pointer::IsActive()
{
	return m_IsActive;
}

void Pointer::ProcessButton(Input::InputId ButtonId, bool Pressed)
{
	m_WidgetMapping.ProcessButton(this, ButtonId, Pressed);
}

void Pointer::ProcessSlider(Input::InputId SliderId, double MovedAmount)
{
	m_WidgetMapping.ProcessSlider(this, SliderId, MovedAmount);
}

void Pointer::ProcessTimePassed(const double TimePassed)
{
}

WidgetMapping & Pointer::GetWidgetMapping()
{
	return m_WidgetMapping;
}
