#include "../../Main.h"

TouchPointer::TouchPointer()
	: Pointer(),
	  m_Touching(false),
	  m_PreviousTouchPosition()
{
}

TouchPointer::~TouchPointer()
{
}

Vector2n & TouchPointer::PreviousTouchPosition()
{
	return m_PreviousTouchPosition;
}

void TouchPointer::ProcessButton(Input::InputId ButtonId, bool Pressed)
{
	// If no buttons were pressed thus far, then the pointer is getting activated
	if (Pressed && !m_Touching)
	{
		Pointer::ProcessActivation();
	}

	m_Touching = Pressed;

	Pointer::ProcessButton(ButtonId, Pressed);

	// If no buttons are pressed anymore, then the pointer is getting deactivated
	if (!Pressed && !m_Touching)
	{
		Pointer::ProcessDeactivation();
	}
}

void TouchPointer::ProcessPosition(Vector2n Position)
{
}
