#include "Main.h"

MultitouchTestScreen::MultitouchTestScreen(InputManager & InputManager)
	: Screen(InputManager)
{
	{
		auto MainCanvas = new Canvas(Vector2n(0, 0), true, true);

		MainCanvas->AddWidget(new MultitouchTestBoxWidget(Vector2n(-200 - 5, -200 - 5)));
		MainCanvas->AddWidget(new MultitouchTestBoxWidget(Vector2n(0 + 5, -200 - 5)));
		MainCanvas->AddWidget(new MultitouchTestBoxWidget(Vector2n(-200 - 5, 0 + 5)));
		MainCanvas->AddWidget(new MultitouchTestBoxWidget(Vector2n(0 + 5, 0 + 5)));
		MainCanvas->AddWidget(new MultitouchTestBoxWidget(Vector2n(100 + 5, 100 + 5)));

		m_Widgets.push_back(std::unique_ptr<Widget>(MainCanvas));		// MainCanvas
	}

	UpdateWindowDimensions(m_InputManager.GetWindowDimensions());
}

MultitouchTestScreen::~MultitouchTestScreen()
{
}

void MultitouchTestScreen::UpdateWindowDimensions(Vector2n WindowDimensions)
{
	reinterpret_cast<Canvas *>(m_Widgets.front().get())->SetDimensions(WindowDimensions);
}
