#include "Main.h"

Screen::Screen(InputManager & InputManager)
	: m_Widgets(),
	  m_InputManager(InputManager)
{
}

Screen::~Screen()
{
}

void Screen::Render()
{
	for (auto & Widget : m_Widgets)
	{
		Widget->Render();
	}
}

void Screen::ProcessPosition(Pointer * Pointer, Vector2n Position)
{
	if (nullptr == Pointer->GetWidgetMapping().GetActiveWidget())
	{
		Pointer->GetWidgetMapping().RemoveHoverPointer(Pointer);		// TODO: Maybe only remove/add when there's change, rather than starting from scratch each time

		std::list<Widget *> Hits;		// Front of list are top-most widgets

		//for (auto & Widget : m_Widgets)
		for (auto Widget = m_Widgets.rbegin(); m_Widgets.rend() != Widget; ++Widget)
		{
			if ((*Widget)->HitTest(Position, &Hits))
				break;		// HACK: I need to do proper query if the HitTest prevents passthrough interest check
		}

		/*std::cout << std::string(100, '\n');
		for (auto & Hit : Hits)
		{
			std::cout << "Hit widget " << Hit << std::endl;
		}*/
		/*OpenGLStream out(Vector2n(0, 0));
		for (auto & Hit : Hits)
		{
			std::stringstream ss;
			ss << "Hit widget " << Hit;
			out << ss.str() << endl;
		}*/

		Pointer->GetWidgetMapping().RemoveAllMappings();
		for (auto & Hit : Hits)
		{
			Pointer->GetWidgetMapping().AddMapping(Hit);
			Hit->AddHoverPointer(Pointer);
		}
		Pointer->GetWidgetMapping().DoneAdding();
	}
}

void Screen::ProcessTimePassed(const double TimePassed)
{
}
