#pragma once
#ifndef __Screen_H__
#define __Screen_H__

class Screen : public PointerInputListener
{
public:
	Screen(InputManager & InputManager);
	virtual ~Screen();

	virtual void UpdateWindowDimensions(Vector2n WindowDimensions) {}

	void Render();

	void ProcessPosition(Pointer * Pointer, Vector2n Position);

	void ProcessTimePassed(const double TimePassed);

protected:
	std::vector<std::unique_ptr<Widget>>		m_Widgets;

	InputManager &								m_InputManager;

private:
	Screen(const Screen &);
	Screen & operator =(const Screen &);
};

#endif // __Screen_H__
