#include "../Main.h"

MultitouchTestBoxWidget::MultitouchTestBoxWidget(Vector2n Position)
	: Widget(Position, Vector2n(200, 200))
{
}

MultitouchTestBoxWidget::~MultitouchTestBoxWidget()
{
}

void MultitouchTestBoxWidget::Render()
{
	Color BackgroundColor(0.99, 0.99, 0.99);
	Color BorderColor(0.5, 0.5, 0.5);

	if (CheckHover())
	{
		BorderColor[0] = 0.898;
		BorderColor[1] = 0.765;
		BorderColor[2] = 0.396;
	}

	DrawBox(m_Position, m_Dimensions, BackgroundColor, BorderColor);
}

void MultitouchTestBoxWidget::ProcessButton(Pointer * Pointer, Input::InputId ButtonId, bool Pressed)
{
	if (0 == ButtonId)
	{
		if (Pressed)
		{
			Pointer->GetWidgetMapping().RequestActivation(this);
		}
		else
		{
			Pointer->GetWidgetMapping().RequestDeactivation(this);
		}
	}
}

void MultitouchTestBoxWidget::ProcessSlider(Pointer * Pointer, Input::InputId SliderId, double MovedAmount)
{
	// TODO: Make it based on this widget being active/having captured the pointer, rather than pointer being active (i.e. not exclusive)
	//if (Pointer->IsActive())
	//if (IsActiveExternally())
	if (this == Pointer->GetWidgetMapping().GetActiveWidget())
	{
		if (0 == SliderId)
		{
			m_Position.X() += static_cast<sint32>(MovedAmount);
		}
		else if (1 == SliderId)
		{
			m_Position.Y() += static_cast<sint32>(MovedAmount);
		}
	}

	/*if (2 == SliderId)
	{
		/*double A[2] = { (GetAxisState(0).GetPosition() - 0.5 * GetAxisState(0).GetLength()),
						(GetAxisState(1).GetPosition() - 0.5 * GetAxisState(1).GetLength()) };* /
		double A[2] = { 0, 0 };
		MoveView(static_cast<uint8>(SliderId), MovedAmount, A);
	}*/
}
