#pragma once
#ifndef __Widget_H__
#define __Widget_H__

class Widget
{
public:
	virtual ~Widget();

	virtual void Render(/*WidgetManager & WidgetManager*/) = 0;

	virtual bool HitTest(Vector2n Position, std::list<Widget *> * Hits) const;

	//virtual void Clicked() {}

	virtual bool ShouldActivate() const;
	virtual bool ShouldDeactivate() const;

	virtual bool ShouldMouseCursorVisible() const { return true; }

	virtual void ProcessActivation() {}
	virtual void ProcessDeactivation() {}

	virtual void ProcessButton(Pointer * Pointer, Input::InputId ButtonId, bool Pressed) {}
	virtual void ProcessSlider(Pointer * Pointer, Input::InputId SliderId, double MovedAmount) {}

	virtual void ProcessTimePassed(const double TimePassed) {}

	//void SetActiveWidgetPointer(Widget ** ActiveWidgetPointer) { m_ActiveWidgetPointer = ActiveWidgetPointer; }
	void AddHoverPointer(Pointer * Pointer);
	void RemoveHoverPointer(Pointer * Pointer);

	/*void SetParent(Widget & Parent);
	Widget * GetParent() const;*/

protected:
	Widget(Vector2n Position, Vector2n m_Dimensions);

	//bool IsActiveExternally() { return (this == *m_ActiveWidgetPointer); }

	bool CheckHover();
	bool CheckActive();

	Vector2n		m_Position;
	Vector2n		m_Dimensions;

private:
	//Widget **				m_ActiveWidgetPointer;
	std::set<Pointer *>		m_HoverPointers;

	//Widget			* m_Parent;
};

#endif // __Widget_H__
